﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.ComponentModel;

namespace WpfApplication1
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
			this.treeView1.ItemsSource = this.CreateItemsSource();
		}

		private void RadTreeView_PreviewSelected(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			DataItem dataItem = e.OriginalSource as DataItem;
			e.Handled = !dataItem.IsSelectable;
		}

		private void RadTreeView_LoadOnDemand(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			RadTreeViewItem treeViewItem = e.OriginalSource as RadTreeViewItem;
			DataItem dataItem = treeViewItem.Item as DataItem;
			dataItem.Children = this.CreateItemsSource();
		}

		private ObservableCollection<DataItem> CreateItemsSource()
		{
			ObservableCollection<DataItem> itemsSource = new ObservableCollection<DataItem>();
			for (int i = 0; i < 10; i++)
			{
				DataItem d1 = new DataItem()
				{
					DisplayName = string.Format("Item {0} [Selectable : {1}]", i, i % 2 != 0),
					IsSelectable = i % 2 != 0,
				};
				itemsSource.Add(d1);
			}
			return itemsSource;
		}

		private void DisableExpander_Click(object sender, RoutedEventArgs e)
		{
			if (this.treeView1.SelectedItem == null)
			{
				return;
			}

			RadTreeViewItem selectedItem = this.treeView1.ContainerFromItemRecursive(this.treeView1.SelectedItem);

			if (selectedItem != null)
			{
				ToggleButton expander = selectedItem.ChildrenOfType<ToggleButton>().FirstOrDefault();
				if (expander != null)
				{
					expander.IsEnabled = !expander.IsEnabled;
				}
			}
		}
	}

	public class DataItem : INotifyPropertyChanged
	{
		private ObservableCollection<DataItem> children = new ObservableCollection<DataItem>();

		public string DisplayName { get; set; }
		public bool IsSelectable { get; set; }

		public ObservableCollection<DataItem> Children
		{
			get
			{
				return this.children;
			}
			set
			{
				if (this.children != value)
				{
					this.children = value;
					this.OnPropertyChanged("Children");
				}
			}
		}

		public event PropertyChangedEventHandler PropertyChanged;

		private void OnPropertyChanged(string propertyName)
		{
			if (this.PropertyChanged != null)
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
}